#ifndef _NEWPASSDLG_CPP
#define _NEWPASSDLG_CPP
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

#include <Windows.H>
#include <Stdio.H>
#include <ShlOBJ.H>
#include <Stdlib.H>

#include "../Resources/Resource.H"

#include "../Headers/NSWFL.H"
#include "../Headers/Package.H"
#include "../Headers/Entry.H"
#include "../Headers/CommonDialog.H"

#include "../Dialogs/MainDlg.H"
#include "../Dialogs/OpenPassDlg.H"
#include "../Dialogs/NewPassDlg.H"

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

//---------------------(Variable Declarations)
HWND NewPassDialog_hWnd = NULL;

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

BOOL CALLBACK NewPassDialog(HWND xHandle, UINT xMessage, WPARAM wParam, LPARAM lParam)
{
    //--------------------------------------------------------------------------

    static HMENU SystemMenu = NULL;

    static HWND BrowseTree_hWnd = NULL;
    static HWND Password1_hWnd = NULL;
    static HWND Password2_hWnd = NULL;
    static HWND PasswordBits_hWnd = NULL;
    static HWND PasswordBitsBar_hWnd = NULL;
    static HWND SaveToLocation_hWnd = NULL;

    //--------------------------------------------------------------------------

    if(xMessage == WM_INITDIALOG) // Received A Initilize Dialog Message
    {
        NewPassDialog_hWnd = xHandle;

        SystemMenu = GetSystemMenu(xHandle, FALSE);
        AppendMenu(SystemMenu, MF_SEPARATOR, 0, 0);
        AppendMenu(SystemMenu, MF_STRING, 1000, "About");

        SendMessage(xHandle, (UINT)WM_SETTEXT, (WPARAM)0, (LPARAM)gsTitleCaption);
        SendMessage(xHandle, WM_SETICON, TRUE, (LPARAM) LoadIcon(ghAppInstance, MAKEINTRESOURCE(IDI_MAIN)) );

        Password1_hWnd = GetDlgItem(xHandle, IDC_PASSWORD1);
        Password2_hWnd = GetDlgItem(xHandle, IDC_PASSWORD2);
        PasswordBitsBar_hWnd = GetDlgItem(xHandle, IDC_PASSWORDBAR2);
        PasswordBits_hWnd = GetDlgItem(xHandle, IDC_PASSWORDBITS2);
        SaveToLocation_hWnd = GetDlgItem(xHandle, IDC_SAVETOLOCATION);

        BrowseTree_hWnd = GetDlgItem(xHandle, IDC_BROWSETREE);

        Set_Text(Password1_hWnd, "9e8t49e8rt4389476i516se56");
        Set_Text(Password2_hWnd, "9e8t49e8rt4389476i516se56");

        CreateTreeImageList(BrowseTree_hWnd);

        InitAlreadyLoaded();

        PopBrowseTree(BrowseTree_hWnd);

        CenterWindow(xHandle);

        return TRUE; // Return TRUE to set the keyboard focus, Otherwise return FALSE
    }

    //--------------------------------------------------------------------------

    if(xMessage == 307) // Key Down
    {
        float PasswordLen1   = 0;
        float PasswordLen2    = 0;
        float EffeciencyBits = 0;

        char LocalTemp[1024];

        PasswordLen1 = (float) SendMessage(Password1_hWnd, WM_GETTEXTLENGTH, 0, 0);
        PasswordLen2 = (float) SendMessage(Password2_hWnd, WM_GETTEXTLENGTH, 0, 0);

        HWND CurrentFocus = GetFocus();

        if(CurrentFocus == Password1_hWnd)
        {
            EffeciencyBits = (PasswordLen1 / 56) * 100;
            SendMessage(PasswordBitsBar_hWnd, PBM_SETPOS, (int) EffeciencyBits, 0);
            sprintf(LocalTemp," (%.0f Bits)", PasswordLen1 * 8);
            Set_Text(PasswordBits_hWnd,LocalTemp);
        }

        if(CurrentFocus == Password2_hWnd)
        {
            EffeciencyBits = (PasswordLen2 / 56) * 100;
            SendMessage(PasswordBitsBar_hWnd, PBM_SETPOS, (int) EffeciencyBits, 0);
            sprintf(LocalTemp," (%.0f Bits)", PasswordLen2 * 8);
            Set_Text(PasswordBits_hWnd,LocalTemp);
        }
    }

    //--------------------------------------------------------------------------

    if(xMessage == WM_NOTIFY)
    {
        NMHDR *lpNMH = (LPNMHDR) lParam;

        if(lpNMH->code == TVN_ITEMEXPANDING || lpNMH->code == TVN_SELCHANGED)
        {
            HTREEITEM hItem = NULL;
            HTREEITEM hParent = NULL;

            char FullSelectedPath[MAX_PATH + 1];
            char Itemtext[MAX_PATH + 1];
            char SelectedPath[MAX_PATH + 1];
            char Parent[MAX_PATH + 1];

            int RPos = 0;
            int WPos = MAX_PATH;

            TVITEMEX tvItemEx;

            memset(&tvItemEx, 0, sizeof(tvItemEx));
            memset(Itemtext, 0, sizeof(Itemtext));

            if(lpNMH->code == TVN_ITEMEXPANDING)
            {
                LPNMTREEVIEW pnmtv = (LPNMTREEVIEW) lParam;
                hItem = pnmtv->itemNew.hItem;
                TreeView_SelectItem(BrowseTree_hWnd, hItem);
            }
            else{
                hItem = TreeView_GetSelection(BrowseTree_hWnd);
            }

            tvItemEx.hItem          = hItem;
            tvItemEx.mask           = TVIF_TEXT;
            tvItemEx.pszText        = Itemtext;
            tvItemEx.cchTextMax     = MAX_PATH;
            TreeView_GetItem(BrowseTree_hWnd, &tvItemEx);

            if(strcmpi(Itemtext, "MyComputer") == 0)
            {
                EnableWindow(GetDlgItem(xHandle, IDC_OK), FALSE);
                return TRUE;
            }

            hParent = hItem;

            bool Append = false;

            while((hParent = TreeView_GetParent(BrowseTree_hWnd, hParent)))
            {
                tvItemEx.hItem          = hParent;
                tvItemEx.mask           = TVIF_TEXT;
                tvItemEx.pszText        = Parent;
                tvItemEx.cchTextMax     = MAX_PATH;
                TreeView_GetItem(BrowseTree_hWnd, &tvItemEx);

                if(strcmpi(Parent, "MyComputer") == 0)
                {
                    break;
                }

                if(strcmpi(Parent, "desktop") == 0)
                {
                    Append = true;
                }
            }

            if(strcmpi(Itemtext, "Desktop") == 0)
            {
                if(GetDesktopFolderPath(FullSelectedPath))
                {
                    Set_Text(SaveToLocation_hWnd, FullSelectedPath);
                    EnableWindow(GetDlgItem(xHandle, IDC_OK), TRUE);
                }
                return TRUE;
            }

            RPos = strlen(Itemtext) - 1;
            while(RPos != -1)
            {
                if(Itemtext[RPos] == '\0') break;
                SelectedPath[WPos] = Itemtext[RPos];
                WPos--;
                RPos--;
            }

            hParent = hItem;

            while( (hParent = TreeView_GetParent(BrowseTree_hWnd, hParent)))
            {
                tvItemEx.hItem          = hParent;
                tvItemEx.mask           = TVIF_TEXT;
                tvItemEx.pszText        = Itemtext;
                tvItemEx.cchTextMax     = MAX_PATH;
                TreeView_GetItem(BrowseTree_hWnd, &tvItemEx);

                if(strcmpi(Itemtext, "Desktop") == 0 || strcmpi(Itemtext, "MyComputer") == 0)
                {
                    break;
                }

                SelectedPath[WPos--] = '\\';

                RPos = strlen(Itemtext) -1;
                while(RPos != -1)
                {
                    if(Itemtext[RPos] == '\0') break;
                    SelectedPath[WPos] = Itemtext[RPos];
                    WPos--;
                    RPos--;
                }
            }

            RPos = WPos+1;
            WPos = 0;
            while(RPos != MAX_PATH+1)
            {
                if(SelectedPath[RPos] == '\0') break;

                FullSelectedPath[WPos] = SelectedPath[RPos];
                WPos++;
                RPos++;
            }

            FullSelectedPath[WPos] = '\0';

            if(Append)
            {
                if(GetDesktopFolderPath(SelectedPath))
                {
                    if(SelectedPath[strlen(SelectedPath) - 1] != '\\')
                        strcat(SelectedPath, "\\");

                    strcat(SelectedPath, FullSelectedPath);
                    Set_Text(SaveToLocation_hWnd, SelectedPath);
                    EnableWindow(GetDlgItem(xHandle, IDC_OK), TRUE);
                    strcpy(FullSelectedPath, SelectedPath);
                }
            }
            else{
                Set_Text(SaveToLocation_hWnd, FullSelectedPath);
            }

            IndexDirectoryForSubItem(BrowseTree_hWnd, hItem, FullSelectedPath, false);

            //---------------------------------------------------------------------------

            HTREEITEM hSibling = NULL;

            strcpy(SelectedPath, FullSelectedPath);

            if((hSibling = TreeView_GetChild(BrowseTree_hWnd, hItem)) != NULL)
            {
                tvItemEx.hItem          = hSibling;
                tvItemEx.mask           = TVIF_TEXT;
                tvItemEx.pszText        = Itemtext;
                tvItemEx.cchTextMax     = MAX_PATH;
                TreeView_GetItem(BrowseTree_hWnd, &tvItemEx);

                strcat(FullSelectedPath, "\\");
                strcat(FullSelectedPath, Itemtext);

                IndexDirectoryForSubItem(BrowseTree_hWnd, hSibling, FullSelectedPath, false);

                while((hSibling = TreeView_GetNextSibling(BrowseTree_hWnd, hSibling)) != NULL)
                {
                    tvItemEx.hItem          = hSibling;
                    tvItemEx.mask           = TVIF_TEXT;
                    tvItemEx.pszText        = Itemtext;
                    tvItemEx.cchTextMax     = MAX_PATH;
                    TreeView_GetItem(BrowseTree_hWnd, &tvItemEx);

                    strcpy(FullSelectedPath, SelectedPath);
                    strcat(FullSelectedPath, "\\");
                    strcat(FullSelectedPath, Itemtext);

                    IndexDirectoryForSubItem(BrowseTree_hWnd, hSibling, FullSelectedPath, false);
                }
            }

            EnableWindow(GetDlgItem(xHandle, IDC_OK), TRUE);
            return TRUE;
        }
    }

    //--------------------------------------------------------------------------

    if(xMessage == WM_COMMAND)
    {
        if(wParam == IDC_OK)
        {
            char lsPassword1[1024 + 1];
            char lsPassword2[1024 + 1];

            int Length1 = Get_TextEx(Password1_hWnd, lsPassword1, 1024);
            int Length2 = Get_TextEx(Password2_hWnd, lsPassword2, 1024);

            if((Length1 < 8 || Length1 > 1024) || (Length2 < 8 || Length2 > 1024))
            {
                MessageBox(xHandle, "Please enter the same password twice. Within 8 and 1,024 characters.", gsTitleCaption, 0);
                return TRUE;
            }

            if(strcmp(lsPassword1, lsPassword2) != 0)
            {
                MessageBox(xHandle, "The passwords you entered do not match.", gsTitleCaption, 0);
                return TRUE;
            }

            strcpy(gsPassword, lsPassword1);

            FreeAlreadyLoaded();
            EndDialog(xHandle, 1);
            return TRUE;
        }

        if(wParam == IDC_CANCEL)
        {
            FreeAlreadyLoaded();
        	EndDialog(xHandle, 0);
            return TRUE;
        }

        return FALSE;
    }

    //--------------------------------------------------------------------------

	if(xMessage == WM_PAINT)
    {
        HDC ThisHDC;
        PAINTSTRUCT ThisPS;

        ThisHDC = BeginPaint(xHandle, &ThisPS);

        // Any painting should be done here

        EndPaint(xHandle, &ThisPS);
        return TRUE;
    }

    //--------------------------------------------------------------------------

    if(xMessage == WM_SYSCOMMAND) // Received A System Menu Message
    {
        if(LOWORD(wParam) == 1000) //- About (SysMenu Command)
        {
            _AboutDialogInfo ADI;
    
            ADI.DisplayIcon  = LoadIcon(ghAppInstance, MAKEINTRESOURCE(IDI_MAIN));
            ADI.TitleCaption = gsTitleCaption;
            ADI.FileVersion  = gsFileVersion;
            ADI.BuildDate    = __DATE__;
            ADI.BuildTime    = __TIME__;
            ADI.CopyRight    = gsAppCopyRight;
            ADI.OwnerHandle  = xHandle;

            NetLogo(&ADI);
            return TRUE;
        }

        return FALSE;
    }

    //--------------------------------------------------------------------------

    if(xMessage == WM_CLOSE)  // Received Close Message
    {
        EndDialog(xHandle, 0);
        FreeAlreadyLoaded();
        return TRUE;
    }

    //--------------------------------------------------------------------------

    return FALSE;
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
#endif

